# iModal :: Boostrap 5
> One modal to rule them all


Simple modals generator. Ideal for ajax requests.

For Bootstrap 4 see branch [bootstrap4](https://github.com/GuxMartin/iModal/tree/bootstrap4).

## Usage
``` javascript
<script src="iModal.js"></script>

// Normal
iModal();

// Update html body
document.querySelector('#iModal .modal-body').html('Custom html');

// Custim id
iModal({id:'my_modal'});

// Custom tite
iModal({title:'Hello world'});

// Sizes
iModal({size:'sm'});
iModal({size:''});// Default
iModal({size:'lg'});
iModal({size:'xl'});

// Fullscreen
iModal({fullscreen:true});
iModal({fullscreen:'sm'});
iModal({fullscreen:'md'});
iModal({fullscreen:'lg'});
iModal({fullscreen:'xl'});
iModal({fullscreen:'xxl'});
iModal({fullscreen:false});// Default

// Custom close button text
iModal({closeText:'Cerrar'});

// Custom default body
iModal({body:'Loading'});

// Header Class
iModal({headerClass:'success'});
iModal({headerClass:'primary'});
iModal({headerClass:'info'});
iModal({headerClass:'warning'});
iModal({headerClass:'danger'});
iModal({headerClass:'secondary'});

// Footer Class
iModal({footerClass:'success'});
iModal({footerClass:'primary'});
iModal({footerClass:'info'});
iModal({footerClass:'warning'});
iModal({footerClass:'danger'});
iModal({footerClass:'secondary'});

// Show/hide header
iModal({header:false});

// Show/hide footer
iModal({footer:false});

// Backdrop
iModal({backdrop:false});

// Backdrop color
iModal({backdropColor:false});
iModal({backdropColor:'success'});
iModal({backdropColor:'primary'});
iModal({backdropColor:'info'});
iModal({backdropColor:'warning'});
iModal({backdropColor:'danger'});
iModal({backdropColor:'secondary'});

// Keyboard
iModal({keyboard:false});

// Dialog scrollable
iModal({dialogScrollable:true});

// Vertically centered
iModal({dialogCentered:true});

// Fade animation
iModal({fade:false});

// Events
iModal({ onShow: function(){ alert('Show'); } });
iModal({ onShowed: function(){ alert('Showed'); } });
iModal({ onHide: function(){ alert('Hide'); } });
iModal({ onHidden: function(){ alert('Hidden'); } });
iModal({ backdrop: 'static', onHidePrevented: function(){ alert('Hide Prevented'); } });

// Methods
iModal('isActive'); // return Boolean
iModal('hide');     // Graceful hidden
iModal('remove');   // Remove iModal
iModal('version');  // return iModal version

// GLOBAL CONFIGURATIONS (after iModal.js)
// Object
iModalSettings = {
  size: 'lg',
  title: 'My project',
  backdrop: false,
};
// or individual
iModalSettings.closeText = 'Cerrar';
iModalSettings.body = 'Loading...';
```

## Documentation and examples
[https://guxmartin.github.io/iModal/examples/bootstrap5/index.html](https://guxmartin.github.io/iModal/examples/bootstrap5/index.html)
