/**
 * iModal for Bootstrap 4
 * Version: 0.12.0
 * Autor: gusma62@gmail.com
 * https://github.com/GuxMartin/iModal
 */

window.iModalDefaults = {
  id: "iModal",
  size: "",
  title: "",
  closeText: "Close",
  body: '<div class="text-center"><div class="spinner-border text-primary" role="status"><span class="sr-only">Loading...</span></div></div>',
  headerClass: "",
  footerClass: "",
  header: true,
  footer: true,
  backdrop: true,
  backdropColor: false,
  keyboard: true,
  dialogScrollable: false,
  dialogCentered: false,
  fade: true,
  onShow: function(){},
  onShowed: function(){},
  onHide: function(){},
  onHidden: function(){},
  onHidePrevented: function(){},
};

window.iModalSettings = {};

window.iModal = function(params){
  if(typeof(params) == 'string'){
    switch(params){
      case 'isActive':
        return $('.modal.iModal').length > 0;
      break;// /isActive
      case 'remove':
        if($('.modal.iModal').length){
          $('.modal.iModal').modal('dispose').remove();
          $('.modal-backdrop').remove();
          $('body').removeClass("modal-open");
        }
      break;// /remove
      case 'hide':
        if(! iModal('isActive')){ return; }
        $('.modal.iModal').modal('hide');
      break;// /hide
      case 'version':
        return "0.12.0";
      break;// /version
      default:
        console.log("Bad option");
      break;
    }// /switch params
    return;
  }// /typeof(params) == 'string'

  var settings = $.extend( {}, iModalDefaults, iModalSettings, params );

  // Array de clases de colores de fondo de bootstrap
  let bgColors = ['success','primary','info','warning','danger','secondary'];

  // Comprobación de parámetros
  if(settings.id.length < 1){ settings.id = iModalDefaults.id; }

  if($.inArray( settings.size, ['sm','lg','xl'] ) < 0 ){ settings.size = iModalDefaults.size; }
  else{ settings.size = 'modal-'+settings.size; }

  if($.inArray( settings.headerClass, bgColors ) < 0 ){ settings.headerClass = iModalDefaults.headerClass; }
  else{ settings.headerClass = 'bg-'+settings.headerClass+' text-white'; }

  if($.inArray( settings.footerClass, bgColors ) < 0 ){ settings.footerClass = iModalDefaults.footerClass; }
  else{ settings.footerClass = 'bg-'+settings.footerClass; }

  if($.inArray( settings.backdrop, [true,false,'static'] ) < 0 ){ settings.backdrop = iModalDefaults.backdrop; }

  if($.inArray( settings.backdropColor, bgColors ) < 0 ){ settings.backdropColor = iModalDefaults.backdropColor; }
  else{ settings.backdropColor = 'bg-'+settings.backdropColor; }

  if($.inArray( settings.keyboard, [true,false] ) < 0 ){ settings.keyboard = iModalDefaults.keyboard; }

  if($.inArray( settings.dialogScrollable, [true,false] ) < 0 ){ settings.dialogScrollable = iModalDefaults.dialogScrollable; }

  if($.inArray( settings.dialogCentered, [true,false] ) < 0 ){ settings.dialogCentered = iModalDefaults.dialogCentered; }

  if($.inArray( settings.fade, [true,false] ) < 0 ){ settings.fade = iModalDefaults.fade; }

  if(settings.keyboard === false){
    settings.backdrop = 'static';// Obligatorio static https://getbootstrap.com/docs/4.5/components/modal/#static-backdrop
  }

  // Si ya existe, destruir para regenerar
  iModal('remove');

  // Construcción del modal
  var html = '';
  html += '<div class="modal '+( settings.fade ? 'fade' : '' )+' iModal" id="'+ settings.id +'" tabindex="-1" role="dialog" aria-labelledby="iModal_label" aria-hidden="true">';
    html += '<div class="modal-dialog '+ settings.size +' '+( settings.dialogScrollable ? 'modal-dialog-scrollable' : '' )+' '+( settings.dialogCentered ? 'modal-dialog-centered' : '' )+'" role="document">';
      html += '<div class="modal-content">';
        if(settings.header){
          html += '<div class="modal-header '+ settings.headerClass +'">';
            html += '<h5 class="modal-title" id="iModal_label">' + settings.title + '</h5>';
            html += '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
          html += '</div>';// /.modal-header
        }
        html += '<div class="modal-body">' + settings.body + '</div>';
        if(settings.footer){
          html += '<div class="modal-footer '+ settings.footerClass +'">';
            html += '<button type="button" class="btn btn-secondary" data-dismiss="modal">' + settings.closeText + '</button>';
          html += '</div>';// /.modal-footer
        }
      html += '</div>';// /.modal-content
    html += '</div>';// /.modal-dialog
  html += '</div>';// /#modal

  $('body').append(html);

  // Events
  $('.modal.iModal').on('show.bs.modal', function (e) {
    settings.onShow();
  });
  $('.modal.iModal').on('shown.bs.modal', function (e) {
    settings.onShowed();
  });
  $('.modal.iModal').on('hide.bs.modal', function (e) {
    settings.onHide();
  });
  $('.modal.iModal').on('hidden.bs.modal', function (e) {
    iModal('remove');// Resultado correcto cuando iModal('isActive');
    settings.onHidden();
  });
  $('.modal.iModal').on('hidePrevented.bs.modal', function (e) {
    settings.onHidePrevented();
  });

  // Generar modal
  $('.modal.iModal').modal({
    backdrop: settings.backdrop,
    keyboard: settings.keyboard,
  });

  // Backdrop Color
  if(settings.backdropColor){
    $('.modal-backdrop').addClass(settings.backdropColor);
  }

};
